﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    Dim table As New DataTable()

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        UltraGrid1.DataSource = CreateTable(table)

        If UltraGrid1.Rows.Count < 3 Then
            UltraGrid1.Height = 150
        Else
            UltraGrid1.Height = 270
        End If

        UltraGrid1.DisplayLayout.Bands(0).Override.SummaryDisplayArea = SummaryDisplayAreas.GroupByRowsFooter Or SummaryDisplayAreas.Bottom
        UltraGrid1.DisplayLayout.Bands(0).Summaries.Add("Band0Summaries1", SummaryType.Formula, UltraGrid1.DisplayLayout.Bands(0).Columns("Name"), SummaryPosition.UseSummaryPositionColumn)
        UltraGrid1.DisplayLayout.Bands(0).Summaries.Add("Band0Summaries2", SummaryType.Sum, UltraGrid1.DisplayLayout.Bands(0).Columns("FirstAmount"), SummaryPosition.UseSummaryPositionColumn)
        UltraGrid1.DisplayLayout.Bands(0).Summaries("Band0Summaries2").DisplayFormat = "Subtotal = {0:#,###}"
        UltraGrid1.DisplayLayout.Bands(0).Summaries.Add("Band0Summaries3", SummaryType.Average, UltraGrid1.DisplayLayout.Bands(0).Columns("SecondAmount"), SummaryPosition.UseSummaryPositionColumn)
        UltraGrid1.DisplayLayout.Bands(0).Summaries("Band0Summaries3").DisplayFormat = "Average = {0:#,###}"
        UltraGrid1.DisplayLayout.Bands(0).SummaryFooterCaption = ""
        UltraGrid1.DisplayLayout.Bands(0).Summaries("Band0Summaries1").DisplayFormat = "Totals:  "

        UltraGrid1.CalcManager = calcManager

    End Sub

    Private Sub UltraGrid1_InitializeLayout(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        UltraGrid1.Font = New Font("Microsoft Sans Serif", 13.25F)
        e.Layout.Override.RowSelectors = DefaultableBoolean.True
        'e.Layout.GroupByBox.Hidden = DefaultableBoolean.True
        e.Layout.Bands(0).Columns(1).Header.Caption = "First Amount"
        e.Layout.Bands(0).Columns(2).Header.Caption = "Second Amount"
        e.Layout.Bands(0).Columns(3).Header.Caption = "Third Amount"
    End Sub

    Public Function CreateTable(ByVal tavola As DataTable) As DataTable
        Dim row As DataRow
        Dim colName As New DataColumn("Name", System.Type.[GetType]("System.String"))
        tavola.Columns.Add(colName)
        Dim colFirstAmount As New DataColumn("FirstAmount", System.Type.[GetType]("System.Decimal"))
        tavola.Columns.Add(colFirstAmount)
        Dim colSecondAmount As New DataColumn("SecondAmount", System.Type.[GetType]("System.Double"))
        tavola.Columns.Add(colSecondAmount)
        Dim colThirdAmount As New DataColumn("ThirdAmount", System.Type.[GetType]("System.Double"))
        tavola.Columns.Add(colThirdAmount)
        row = tavola.NewRow()
        row("Name") = "Mannie"
        row("FirstAmount") = 50
        row("SecondAmount") = 100
        row("ThirdAmount") = 110
        tavola.Rows.Add(row)

        row = tavola.NewRow()
        row("Name") = "Moe"
        row("FirstAmount") = 150
        row("SecondAmount") = 300
        row("ThirdAmount") = 120
        tavola.Rows.Add(row)

        row = tavola.NewRow()
        row("Name") = "Jack"
        row("FirstAmount") = 100
        row("SecondAmount") = 200
        row("ThirdAmount") = 110
        tavola.Rows.Add(row)
        Return tavola
    End Function
End Class
